﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

// The User Control item template is documented at http://go.microsoft.com/fwlink/?LinkId=234236

namespace pdftron.PDF.Tools.ToolSettings
{
    public sealed partial class FreeTextFontControl : UserControl
    {
        private FreeTextFontViewModel _ViewModel = null;

        public FreeTextFontControl()
        {
            this.InitializeComponent();
            _ViewModel = new FreeTextFontViewModel();
            this.DataContext = _ViewModel;
            _ViewModel.SelectedItemProvider = GetSelectedItems;
            SelectWhiteListedFonts();
        }

        public List<TextAnnotationFontItem> GetSelectedItems()
        {
            List<TextAnnotationFontItem> selectedItems = new List<TextAnnotationFontItem>();
            foreach (object item in FullFontListView.SelectedItems)
            {
                TextAnnotationFontItem fontItem = item as TextAnnotationFontItem;
                if (fontItem != null)
                {
                    selectedItems.Add(fontItem);
                }
            }
            return selectedItems;
        }

        public void SelectWhiteListedFonts()
        {
            if (_ViewModel != null && _ViewModel.FontItems != null)
            {
                HashSet<string> fontWhiteList = Settings.FontWhiteList;
                foreach (TextAnnotationFontItem item in _ViewModel.FontItems)
                {
                    if (fontWhiteList.Contains(item.FontName))
                    {
                        FullFontListView.SelectedItems.Add(item);
                    }
                }
            }
        }

        public void Close()
        {
            _ViewModel.CleanUp();
        }
    }
}
